package com.fjhx.service.water;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.fjhx.base.Condition;
import com.fjhx.base.StorageBaseService;
import com.fjhx.entity.water.WaterBack;
import com.fjhx.params.water.WaterBackAddVo;
import com.fjhx.params.water.WaterBackVo;

import java.util.List;
import java.util.Map;

/**
 * <p>
 * 退料 服务类
 * </p>
 *
 * @author ${author}
 * @since 2022-10-27
 */
public interface WaterBackService extends StorageBaseService<WaterBack> {

    /**
     * 添加退货列表
     */
    void add(List<WaterBackAddVo> waterBackAddVoList);

    /**
     * 待复核列表
     */
    List<Map<String, Object>> toBeReviewedList();

    /**
     * 明细
     */
    List<Map<String, Object>> details(Long waterBackId);

    /**
     * 删除
     */
    void delete(Long waterBackId);

    /**
     * 提交
     */
    void submit(WaterBackVo waterBackVo);

    /**
     * 获取直喷打纸热转部门用户
     *
     * @return
     */
    Map<String, JSONObject> getUserByAppointDept();

    /**
     * 获取直喷打纸热转部门用户
     */
    List<Long> getUserIdByAppointDept(Long... deptId);

    /**
     * 退仓看板统计
     */
    Map<String, Object> statistics(Condition condition);

    /**
     * 退仓看板分页
     */
    Page<Map<String, Object>> getPage(Condition condition);

}
